test-lib: use subshell instead of cd $new && .. && cd $old
[git/dscho.git] / t / test-lib.sh
blobee3d073791c0ae95e44a9b99de839d15e20c0a24
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22 # do not redirect again
24 *' --tee '*|*' --va'*)
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 LANGUAGE=C
41 PAGER=cat
42 TZ=UTC
43 TERM=dumb
44 export LANG LC_ALL PAGER TERM TZ
45 EDITOR=:
46 unset VISUAL
47 unset GIT_EDITOR
48 unset AUTHOR_DATE
49 unset AUTHOR_EMAIL
50 unset AUTHOR_NAME
51 unset COMMIT_AUTHOR_EMAIL
52 unset COMMIT_AUTHOR_NAME
53 unset EMAIL
54 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
55 unset GIT_AUTHOR_DATE
56 GIT_AUTHOR_EMAIL=author@example.com
57 GIT_AUTHOR_NAME='A U Thor'
58 unset GIT_COMMITTER_DATE
59 GIT_COMMITTER_EMAIL=committer@example.com
60 GIT_COMMITTER_NAME='C O Mitter'
61 unset GIT_DIFF_OPTS
62 unset GIT_DIR
63 unset GIT_WORK_TREE
64 unset GIT_EXTERNAL_DIFF
65 unset GIT_INDEX_FILE
66 unset GIT_OBJECT_DIRECTORY
67 unset GIT_CEILING_DIRECTORIES
68 unset SHA1_FILE_DIRECTORIES
69 unset SHA1_FILE_DIRECTORY
70 unset GIT_NOTES_REF
71 unset GIT_NOTES_DISPLAY_REF
72 unset GIT_NOTES_REWRITE_REF
73 unset GIT_NOTES_REWRITE_MODE
74 GIT_MERGE_VERBOSITY=5
75 export GIT_MERGE_VERBOSITY
76 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
77 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
78 export EDITOR
80 # Protect ourselves from common misconfiguration to export
81 # CDPATH into the environment
82 unset CDPATH
84 unset GREP_OPTIONS
86 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
87 1|2|true)
88 echo "* warning: Some tests will not work if GIT_TRACE" \
89 "is set as to trace on STDERR ! *"
90 echo "* warning: Please set GIT_TRACE to something" \
91 "other than 1, 2 or true ! *"
93 esac
95 # Convenience
97 # A regexp to match 5 and 40 hexdigits
98 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
99 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
101 # Each test should start with something like this, after copyright notices:
103 # test_description='Description of this test...
104 # This test checks if command xyzzy does the right thing...
106 # . ./test-lib.sh
107 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
108 TERM=$ORIGINAL_TERM &&
109 export TERM &&
110 [ -t 1 ] &&
111 tput bold >/dev/null 2>&1 &&
112 tput setaf 1 >/dev/null 2>&1 &&
113 tput sgr0 >/dev/null 2>&1
114 ) &&
115 color=t
117 while test "$#" -ne 0
119 case "$1" in
120 -d|--d|--de|--deb|--debu|--debug)
121 debug=t; shift ;;
122 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
123 immediate=t; shift ;;
124 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
125 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
126 -h|--h|--he|--hel|--help)
127 help=t; shift ;;
128 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
129 verbose=t; shift ;;
130 -q|--q|--qu|--qui|--quie|--quiet)
131 # Ignore --quiet under a TAP::Harness. Saying how many tests
132 # passed without the ok/not ok details is always an error.
133 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
134 --with-dashes)
135 with_dashes=t; shift ;;
136 --no-color)
137 color=; shift ;;
138 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
139 valgrind=t; verbose=t; shift ;;
140 --tee)
141 shift ;; # was handled already
142 --root=*)
143 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
144 shift ;;
146 echo "error: unknown test option '$1'" >&2; exit 1 ;;
147 esac
148 done
150 if test -n "$color"; then
151 say_color () {
153 TERM=$ORIGINAL_TERM
154 export TERM
155 case "$1" in
156 error) tput bold; tput setaf 1;; # bold red
157 skip) tput bold; tput setaf 2;; # bold green
158 pass) tput setaf 2;; # green
159 info) tput setaf 3;; # brown
160 *) test -n "$quiet" && return;;
161 esac
162 shift
163 printf "%s" "$*"
164 tput sgr0
165 echo
168 else
169 say_color() {
170 test -z "$1" && test -n "$quiet" && return
171 shift
172 echo "$*"
176 error () {
177 say_color error "error: $*"
178 GIT_EXIT_OK=t
179 exit 1
182 say () {
183 say_color info "$*"
186 test "${test_description}" != "" ||
187 error "Test script did not set test_description."
189 if test "$help" = "t"
190 then
191 echo "$test_description"
192 exit 0
195 exec 5>&1
196 if test "$verbose" = "t"
197 then
198 exec 4>&2 3>&1
199 else
200 exec 4>/dev/null 3>/dev/null
203 test_failure=0
204 test_count=0
205 test_fixed=0
206 test_broken=0
207 test_success=0
209 test_external_has_tap=0
211 die () {
212 code=$?
213 if test -n "$GIT_EXIT_OK"
214 then
215 exit $code
216 else
217 echo >&5 "FATAL: Unexpected exit with code $code"
218 exit 1
222 GIT_EXIT_OK=
223 trap 'die' EXIT
225 # The semantics of the editor variables are that of invoking
226 # sh -c "$EDITOR \"$@\"" files ...
228 # If our trash directory contains shell metacharacters, they will be
229 # interpreted if we just set $EDITOR directly, so do a little dance with
230 # environment variables to work around this.
232 # In particular, quoting isn't enough, as the path may contain the same quote
233 # that we're using.
234 test_set_editor () {
235 FAKE_EDITOR="$1"
236 export FAKE_EDITOR
237 EDITOR='"$FAKE_EDITOR"'
238 export EDITOR
241 test_decode_color () {
242 sed -e 's/.\[1m/<WHITE>/g' \
243 -e 's/.\[31m/<RED>/g' \
244 -e 's/.\[32m/<GREEN>/g' \
245 -e 's/.\[33m/<YELLOW>/g' \
246 -e 's/.\[34m/<BLUE>/g' \
247 -e 's/.\[35m/<MAGENTA>/g' \
248 -e 's/.\[36m/<CYAN>/g' \
249 -e 's/.\[m/<RESET>/g'
252 q_to_nul () {
253 perl -pe 'y/Q/\000/'
256 q_to_cr () {
257 tr Q '\015'
260 append_cr () {
261 sed -e 's/$/Q/' | tr Q '\015'
264 remove_cr () {
265 tr '\015' Q | sed -e 's/Q$//'
268 test_tick () {
269 if test -z "${test_tick+set}"
270 then
271 test_tick=1112911993
272 else
273 test_tick=$(($test_tick + 60))
275 GIT_COMMITTER_DATE="$test_tick -0700"
276 GIT_AUTHOR_DATE="$test_tick -0700"
277 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
280 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
282 # This will commit a file with the given contents and the given commit
283 # message. It will also add a tag with <message> as name.
285 # Both <file> and <contents> default to <message>.
287 test_commit () {
288 file=${2:-"$1.t"}
289 echo "${3-$1}" > "$file" &&
290 git add "$file" &&
291 test_tick &&
292 git commit -m "$1" &&
293 git tag "$1"
296 # Call test_merge with the arguments "<message> <commit>", where <commit>
297 # can be a tag pointing to the commit-to-merge.
299 test_merge () {
300 test_tick &&
301 git merge -m "$1" "$2" &&
302 git tag "$1"
305 # This function helps systems where core.filemode=false is set.
306 # Use it instead of plain 'chmod +x' to set or unset the executable bit
307 # of a file in the working directory and add it to the index.
309 test_chmod () {
310 chmod "$@" &&
311 git update-index --add "--chmod=$@"
314 # Use test_set_prereq to tell that a particular prerequisite is available.
315 # The prerequisite can later be checked for in two ways:
317 # - Explicitly using test_have_prereq.
319 # - Implicitly by specifying the prerequisite tag in the calls to
320 # test_expect_{success,failure,code}.
322 # The single parameter is the prerequisite tag (a simple word, in all
323 # capital letters by convention).
325 test_set_prereq () {
326 satisfied="$satisfied$1 "
328 satisfied=" "
330 test_have_prereq () {
331 # prerequisites can be concatenated with ','
332 save_IFS=$IFS
333 IFS=,
334 set -- $*
335 IFS=$save_IFS
337 total_prereq=0
338 ok_prereq=0
339 missing_prereq=
341 for prerequisite
343 total_prereq=$(($total_prereq + 1))
344 case $satisfied in
345 *" $prerequisite "*)
346 ok_prereq=$(($ok_prereq + 1))
349 # Keep a list of missing prerequisites
350 if test -z "$missing_prereq"
351 then
352 missing_prereq=$prerequisite
353 else
354 missing_prereq="$prerequisite,$missing_prereq"
356 esac
357 done
359 test $total_prereq = $ok_prereq
362 # You are not expected to call test_ok_ and test_failure_ directly, use
363 # the text_expect_* functions instead.
365 test_ok_ () {
366 test_success=$(($test_success + 1))
367 say_color "" "ok $test_count - $@"
370 test_failure_ () {
371 test_failure=$(($test_failure + 1))
372 say_color error "not ok - $test_count $1"
373 shift
374 echo "$@" | sed -e 's/^/# /'
375 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
378 test_known_broken_ok_ () {
379 test_fixed=$(($test_fixed+1))
380 say_color "" "ok $test_count - $@ # TODO known breakage"
383 test_known_broken_failure_ () {
384 test_broken=$(($test_broken+1))
385 say_color skip "not ok $test_count - $@ # TODO known breakage"
388 test_debug () {
389 test "$debug" = "" || eval "$1"
392 test_run_ () {
393 test_cleanup=:
394 eval >&3 2>&4 "$1"
395 eval_ret=$?
396 eval >&3 2>&4 "$test_cleanup"
397 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
398 echo ""
400 return 0
403 test_skip () {
404 test_count=$(($test_count+1))
405 to_skip=
406 for skp in $GIT_SKIP_TESTS
408 case $this_test.$test_count in
409 $skp)
410 to_skip=t
411 break
412 esac
413 done
414 if test -z "$to_skip" && test -n "$prereq" &&
415 ! test_have_prereq "$prereq"
416 then
417 to_skip=t
419 case "$to_skip" in
421 of_prereq=
422 if test "$missing_prereq" != "$prereq"
423 then
424 of_prereq=" of $prereq"
427 say_color skip >&3 "skipping test: $@"
428 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
429 : true
432 false
434 esac
437 test_expect_failure () {
438 test "$#" = 3 && { prereq=$1; shift; } || prereq=
439 test "$#" = 2 ||
440 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
441 if ! test_skip "$@"
442 then
443 say >&3 "checking known breakage: $2"
444 test_run_ "$2"
445 if [ "$?" = 0 -a "$eval_ret" = 0 ]
446 then
447 test_known_broken_ok_ "$1"
448 else
449 test_known_broken_failure_ "$1"
452 echo >&3 ""
455 test_expect_success () {
456 test "$#" = 3 && { prereq=$1; shift; } || prereq=
457 test "$#" = 2 ||
458 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
459 if ! test_skip "$@"
460 then
461 say >&3 "expecting success: $2"
462 test_run_ "$2"
463 if [ "$?" = 0 -a "$eval_ret" = 0 ]
464 then
465 test_ok_ "$1"
466 else
467 test_failure_ "$@"
470 echo >&3 ""
473 test_expect_code () {
474 test "$#" = 4 && { prereq=$1; shift; } || prereq=
475 test "$#" = 3 ||
476 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
477 if ! test_skip "$@"
478 then
479 say >&3 "expecting exit code $1: $3"
480 test_run_ "$3"
481 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
482 then
483 test_ok_ "$2"
484 else
485 test_failure_ "$@"
488 echo >&3 ""
491 # test_external runs external test scripts that provide continuous
492 # test output about their progress, and succeeds/fails on
493 # zero/non-zero exit code. It outputs the test output on stdout even
494 # in non-verbose mode, and announces the external script with "# run
495 # <n>: ..." before running it. When providing relative paths, keep in
496 # mind that all scripts run in "trash directory".
497 # Usage: test_external description command arguments...
498 # Example: test_external 'Perl API' perl ../path/to/test.pl
499 test_external () {
500 test "$#" = 4 && { prereq=$1; shift; } || prereq=
501 test "$#" = 3 ||
502 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
503 descr="$1"
504 shift
505 if ! test_skip "$descr" "$@"
506 then
507 # Announce the script to reduce confusion about the
508 # test output that follows.
509 say_color "" "# run $test_count: $descr ($*)"
510 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
511 # to be able to use them in script
512 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
513 # Run command; redirect its stderr to &4 as in
514 # test_run_, but keep its stdout on our stdout even in
515 # non-verbose mode.
516 "$@" 2>&4
517 if [ "$?" = 0 ]
518 then
519 if test $test_external_has_tap -eq 0; then
520 test_ok_ "$descr"
521 else
522 say_color "" "# test_external test $descr was ok"
523 test_success=$(($test_success + 1))
525 else
526 if test $test_external_has_tap -eq 0; then
527 test_failure_ "$descr" "$@"
528 else
529 say_color error "# test_external test $descr failed: $@"
530 test_failure=$(($test_failure + 1))
536 # Like test_external, but in addition tests that the command generated
537 # no output on stderr.
538 test_external_without_stderr () {
539 # The temporary file has no (and must have no) security
540 # implications.
541 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
542 stderr="$tmp/git-external-stderr.$$.tmp"
543 test_external "$@" 4> "$stderr"
544 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
545 descr="no stderr: $1"
546 shift
547 say >&3 "# expecting no stderr from previous command"
548 if [ ! -s "$stderr" ]; then
549 rm "$stderr"
551 if test $test_external_has_tap -eq 0; then
552 test_ok_ "$descr"
553 else
554 say_color "" "# test_external_without_stderr test $descr was ok"
555 test_success=$(($test_success + 1))
557 else
558 if [ "$verbose" = t ]; then
559 output=`echo; echo "# Stderr is:"; cat "$stderr"`
560 else
561 output=
563 # rm first in case test_failure exits.
564 rm "$stderr"
565 if test $test_external_has_tap -eq 0; then
566 test_failure_ "$descr" "$@" "$output"
567 else
568 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
569 test_failure=$(($test_failure + 1))
574 # This is not among top-level (test_expect_success | test_expect_failure)
575 # but is a prefix that can be used in the test script, like:
577 # test_expect_success 'complain and die' '
578 # do something &&
579 # do something else &&
580 # test_must_fail git checkout ../outerspace
583 # Writing this as "! git checkout ../outerspace" is wrong, because
584 # the failure could be due to a segv. We want a controlled failure.
586 test_must_fail () {
587 "$@"
588 test $? -gt 0 -a $? -le 129 -o $? -gt 192
591 # Similar to test_must_fail, but tolerates success, too. This is
592 # meant to be used in contexts like:
594 # test_expect_success 'some command works without configuration' '
595 # test_might_fail git config --unset all.configuration &&
596 # do something
599 # Writing "git config --unset all.configuration || :" would be wrong,
600 # because we want to notice if it fails due to segv.
602 test_might_fail () {
603 "$@"
604 test $? -ge 0 -a $? -le 129 -o $? -gt 192
607 # test_cmp is a helper function to compare actual and expected output.
608 # You can use it like:
610 # test_expect_success 'foo works' '
611 # echo expected >expected &&
612 # foo >actual &&
613 # test_cmp expected actual
616 # This could be written as either "cmp" or "diff -u", but:
617 # - cmp's output is not nearly as easy to read as diff -u
618 # - not all diff versions understand "-u"
620 test_cmp() {
621 $GIT_TEST_CMP "$@"
624 # This function can be used to schedule some commands to be run
625 # unconditionally at the end of the test to restore sanity:
627 # test_expect_success 'test core.capslock' '
628 # git config core.capslock true &&
629 # test_when_finished "git config --unset core.capslock" &&
630 # hello world
633 # That would be roughly equivalent to
635 # test_expect_success 'test core.capslock' '
636 # git config core.capslock true &&
637 # hello world
638 # git config --unset core.capslock
641 # except that the greeting and config --unset must both succeed for
642 # the test to pass.
644 test_when_finished () {
645 test_cleanup="{ $*
646 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
649 # Most tests can use the created repository, but some may need to create more.
650 # Usage: test_create_repo <directory>
651 test_create_repo () {
652 test "$#" = 1 ||
653 error "bug in the test script: not 1 parameter to test-create-repo"
654 repo="$1"
655 mkdir -p "$repo"
657 cd "$repo" || error "Cannot setup test environment"
658 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
659 error "cannot run git init -- have you built things yet?"
660 mv .git/hooks .git/hooks-disabled
661 ) || exit
664 test_done () {
665 GIT_EXIT_OK=t
667 if test -z "$HARNESS_ACTIVE"; then
668 test_results_dir="$TEST_DIRECTORY/test-results"
669 mkdir -p "$test_results_dir"
670 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
672 echo "total $test_count" >> $test_results_path
673 echo "success $test_success" >> $test_results_path
674 echo "fixed $test_fixed" >> $test_results_path
675 echo "broken $test_broken" >> $test_results_path
676 echo "failed $test_failure" >> $test_results_path
677 echo "" >> $test_results_path
680 if test "$test_fixed" != 0
681 then
682 say_color pass "# fixed $test_fixed known breakage(s)"
684 if test "$test_broken" != 0
685 then
686 say_color error "# still have $test_broken known breakage(s)"
687 msg="remaining $(($test_count-$test_broken)) test(s)"
688 else
689 msg="$test_count test(s)"
691 case "$test_failure" in
693 # Maybe print SKIP message
694 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
696 if test $test_external_has_tap -eq 0; then
697 say_color pass "# passed all $msg"
698 say "1..$test_count$skip_all"
701 test -d "$remove_trash" &&
702 cd "$(dirname "$remove_trash")" &&
703 rm -rf "$(basename "$remove_trash")"
705 exit 0 ;;
708 if test $test_external_has_tap -eq 0; then
709 say_color error "# failed $test_failure among $msg"
710 say "1..$test_count"
713 exit 1 ;;
715 esac
718 # Test the binaries we have just built. The tests are kept in
719 # t/ subdirectory and are run in 'trash directory' subdirectory.
720 if test -z "$TEST_DIRECTORY"
721 then
722 # We allow tests to override this, in case they want to run tests
723 # outside of t/, e.g. for running tests on the test library
724 # itself.
725 TEST_DIRECTORY=$(pwd)
727 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
729 if test -n "$valgrind"
730 then
731 make_symlink () {
732 test -h "$2" &&
733 test "$1" = "$(readlink "$2")" || {
734 # be super paranoid
735 if mkdir "$2".lock
736 then
737 rm -f "$2" &&
738 ln -s "$1" "$2" &&
739 rm -r "$2".lock
740 else
741 while test -d "$2".lock
743 say "Waiting for lock on $2."
744 sleep 1
745 done
750 make_valgrind_symlink () {
751 # handle only executables
752 test -x "$1" || return
754 base=$(basename "$1")
755 symlink_target=$GIT_BUILD_DIR/$base
756 # do not override scripts
757 if test -x "$symlink_target" &&
758 test ! -d "$symlink_target" &&
759 test "#!" != "$(head -c 2 < "$symlink_target")"
760 then
761 symlink_target=../valgrind.sh
763 case "$base" in
764 *.sh|*.perl)
765 symlink_target=../unprocessed-script
766 esac
767 # create the link, or replace it if it is out of date
768 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
771 # override all git executables in TEST_DIRECTORY/..
772 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
773 mkdir -p "$GIT_VALGRIND"/bin
774 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
776 make_valgrind_symlink $file
777 done
778 OLDIFS=$IFS
779 IFS=:
780 for path in $PATH
782 ls "$path"/git-* 2> /dev/null |
783 while read file
785 make_valgrind_symlink "$file"
786 done
787 done
788 IFS=$OLDIFS
789 PATH=$GIT_VALGRIND/bin:$PATH
790 GIT_EXEC_PATH=$GIT_VALGRIND/bin
791 export GIT_VALGRIND
792 elif test -n "$GIT_TEST_INSTALLED" ; then
793 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
794 error "Cannot run git from $GIT_TEST_INSTALLED."
795 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
796 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
797 else # normal case, use ../bin-wrappers only unless $with_dashes:
798 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
799 if ! test -x "$git_bin_dir/git" ; then
800 if test -z "$with_dashes" ; then
801 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
803 with_dashes=t
805 PATH="$git_bin_dir:$PATH"
806 GIT_EXEC_PATH=$GIT_BUILD_DIR
807 if test -n "$with_dashes" ; then
808 PATH="$GIT_BUILD_DIR:$PATH"
811 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
812 unset GIT_CONFIG
813 GIT_CONFIG_NOSYSTEM=1
814 GIT_CONFIG_NOGLOBAL=1
815 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
817 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
819 if test -z "$GIT_TEST_CMP"
820 then
821 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
822 then
823 GIT_TEST_CMP="$DIFF -c"
824 else
825 GIT_TEST_CMP="$DIFF -u"
829 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
830 export GITPERLLIB
831 test -d "$GIT_BUILD_DIR"/templates/blt || {
832 error "You haven't built things yet, have you?"
835 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
836 then
837 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
838 export GITPYTHONLIB
839 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
840 error "You haven't built git_remote_helpers yet, have you?"
844 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
845 echo >&2 'You need to build test-chmtime:'
846 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
847 exit 1
850 # Test repository
851 test="trash directory.$(basename "$0" .sh)"
852 test -n "$root" && test="$root/$test"
853 case "$test" in
854 /*) TRASH_DIRECTORY="$test" ;;
855 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
856 esac
857 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
858 rm -fr "$test" || {
859 GIT_EXIT_OK=t
860 echo >&5 "FATAL: Cannot prepare test area"
861 exit 1
864 test_create_repo "$test"
865 # Use -P to resolve symlinks in our working directory so that the cwd
866 # in subprocesses like git equals our $PWD (for pathname comparisons).
867 cd -P "$test" || exit 1
869 this_test=${0##*/}
870 this_test=${this_test%%-*}
871 for skp in $GIT_SKIP_TESTS
873 case "$this_test" in
874 $skp)
875 say_color skip >&3 "skipping test $this_test altogether"
876 skip_all="skip all tests in $this_test"
877 test_done
878 esac
879 done
881 # Provide an implementation of the 'yes' utility
882 yes () {
883 if test $# = 0
884 then
886 else
887 y="$*"
890 while echo "$y"
893 done
896 # Fix some commands on Windows
897 case $(uname -s) in
898 *MINGW*)
899 # Windows has its own (incompatible) sort and find
900 sort () {
901 /usr/bin/sort "$@"
903 find () {
904 /usr/bin/find "$@"
906 sum () {
907 md5sum "$@"
909 # git sees Windows-style pwd
910 pwd () {
911 builtin pwd -W
913 # no POSIX permissions
914 # backslashes in pathspec are converted to '/'
915 # exec does not inherit the PID
918 test_set_prereq POSIXPERM
919 test_set_prereq BSLASHPSPEC
920 test_set_prereq EXECKEEPSPID
922 esac
924 test -z "$NO_PERL" && test_set_prereq PERL
925 test -z "$NO_PYTHON" && test_set_prereq PYTHON
926 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
928 # test whether the filesystem supports symbolic links
929 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
930 rm -f y
932 # When the tests are run as root, permission tests will report that
933 # things are writable when they shouldn't be.
934 test -w / || test_set_prereq SANITY